function StatisticService(){
    if(arguments.callee._singletonInstance){
	    return arguments.callee._singletonInstance;
	}
	arguments.callee._singletonInstance = this;

	var self = this; self.name = "StatisticService"; // MANDATORY

    this.stats_interval = 64000;
    this.stats_timer = 0;
    this.stats_working = false;
    this.stats_working_init = false;
    this.analytic_working = false;
    this.list = [];
    this.listIndex = -1;
    this.countWorking = 0;
    this.dayCount = 0;

    this.init = function(){
        if(!self.stats_timer){
            self.stats_timer = setTimeout(self.collect,self.stats_interval);
        }
    };

    this.collect= function(){
        clearTimeout(self.stats_timer);
        self.log("# Statistics beat .... stats_working_init: "+self.stats_working_init+" stats working : "+self.stats_working+" analytics working : "+self.analytic_working);
        self.countWorking++;
        if(!self.stats_working_init){
            self.stats_working_init = true;
            self.stats_working = true;
            self.internet_connected = self.OS.internetConnected();
            self.log("# collect self.internet_connected: "+self.internet_connected)
            if(self.internet_connected){
                self.dayCount = 0;
                self.hourCount = 0;
                self.sendStats(self.getDayOfWeek());
                //self.stats_working = false;
            }else{
                self.log("# Statistics send ... no internet");
                self.notifyError(self.ERROR['STATISTIC_SERVICE']+1,self.name+": Function analyzeFile() : internet connection LOST ! ");
                self.OS.readDirectory(self.ROUTES['STAT'].path,self.package);
            }
        }
        else{
            if(!self.stats_working){
                self.stats_working = true;
                self.OS.readDirectory(self.ROUTES['STAT'].path,self.package);
            }
        }

        if(!self.analytic_working){
            self.log("analytics start");
            self.analytic_working = true;
            self.OS.readDirectory(self.ROUTES['ANALYTIC'].path,self.sendAnalytics);
        }
        if(self.countWorking > 5){
            self.stats_working_init = false;
        }
        self.stats_timer = setTimeout(self.collect,self.stats_interval);
    };

    this.sendAnalytics = function(files){
        self.log("sending analytics ...");
        var count = 0;
        for(var i in files){
          if(count < 100){
              count++;
              if(typeof(files[i]) !== "undefined"){
                  if(files[i] != ""){
                        if(self.platform == "SOC"){
                            files[i] = files[i].substring(2,stat_file.length-1);
                        }
                        var extension = files[i].substring(files[i].lastIndexOf('.'),files[i].length);
                        if(extension == ".json"){
                            self.OS.readFile(self.ROUTES['ANALYTIC'].path+files[i],function(data,file_ref,params){
                              if(data != ""){
                                  var timestamp = parseInt(self.getDate().getTime()/1000);
                                  var post_data = "device="+self.core_id+"&tstamp="+timestamp+"&type=play&data=["+data+"]";
                                  self.api_connector.post(self.iot_url,self.iot_ver,"analytics/push",post_data,function(response,status,params){
                                      if(status == "success"){
                                          self.log("try to delete :"+file_ref);
                                          self.OS.deleteFile(file_ref,function(ok,file_ref,params){
                                              if(ok){
                                                  self.log("Send analytic ok");
                                              }else{
                                                  self.log("Warning : unable to delete analytic : "+file_ref);
                                                  self.notifyError(self.ERROR['STATISTIC_SERVICE']+5,self.name+": Function sendAnalytics() failed : Warning : unable to delete analytic: "+file_ref);
                                              }
                                          });
                                      }else{
                                          self.log("Could not send analytics : "+file_ref+" response : "+response);
                                          self.notifyError(self.ERROR['STATISTIC_SERVICE']+6,self.name+": Function sendAnalytics() failed : Could not send analytic: "+file_ref+" response : "+response);
                                      }
                                  });
                              }
                            });
                        }
                  }
              }
          }else{
            self.log("Count MAX");
            break;;
          }

        }
        self.analytic_working = false;
    };

    this.package = function(files){
        if(files.length > 1){
          self.log("package: "+ files.length)
            self.list = files;
            self.listIndex = -1;
            self.analyzeFile();
        }else{
            self.stats_working = false;
        }
    };

    this.analyzeFile = function(){
      try{
        self.listIndex++;
        self.log(self.list);
        self.log(self.list.length);
        self.log("# analyzeFile listIndex: "+self.listIndex);
        self.log("# analyzeFile self.list.length-1: " + self.list.length-1);
        if(self.listIndex < self.list.length-1){
            var stat_file = self.list[self.listIndex];
            if(typeof(stat_file) !== "undefined"){
                if(stat_file != ""){
                    if(self.platform == "SOC"){
                        stat_file = stat_file.substring(2,stat_file.length-1);
                    }
                    var extension = stat_file.substring(stat_file.lastIndexOf('.'),stat_file.length);
                    if(extension == ".json"){
                        self.OS.readFile(self.ROUTES['STAT'].path+stat_file,function(data,file_ref,params){
                            self.log("# Adding stat : "+data);
                            self.addStat(self.ROUTES['STAT'].path+stat_file,data);
                        });
                    }else{
                        self.analyzeFile();
                    }
                }else{
                    self.analyzeFile();
                }
            }else{
                self.analyzeFile();
            }
        }else{
            self.internet_connected = self.OS.internetConnected();
            self.log("# analyzeFile self.internet_connected: "+self.internet_connected)
            if(self.internet_connected){
                self.dayCount = 0;
                self.hourCount = 0;
                self.sendStats(self.getDayOfWeek());
                //self.stats_working = false;
            }else{
                self.log("# Statistics send ... no internet");
                self.stats_working = false;
                self.notifyError(self.ERROR['STATISTIC_SERVICE']+1,self.name+": Function analyzeFile() : internet connection LOST ! ");
            }
        }
      }
      catch(e){
        self.log("# analyzeFile error: ");
        self.log(JSON.stringify(e));
        self.stats_working = false;
        self.notifyError(self.ERROR['STATISTIC_SERVICE']+1,self.name+": Function analyzeFile() : error "+ JSON.stringify(e));
      }
    };

    this.addStat = function(filepath,value){
        self.log("Read stat value : "+value);
        var date = self.getDate(true);
        var dow = self.getDayOfWeek();
        var hour = date.getHours();
        var today = ""+date.getFullYear()+""+date.getMonth()+""+date.getDate();
        self.log("This day : "+today);
        var name = self.ROUTES['STAT'].path+dow+".pack";
        if(hour < 6 ){
        	name = self.ROUTES['STAT'].path+"6_"+dow+".pack";
        }
        else{
        	if(hour < 12 ){
            	name = self.ROUTES['STAT'].path+"12_"+dow+".pack";
            }
        	else{
        		if(hour < 18 ){
                	name = self.ROUTES['STAT'].path+"18_"+dow+".pack";
                }
        		else{
        			name = self.ROUTES['STAT'].path+"24_"+dow+".pack";
        		}
        	}
        }
        self.OS.readFile(name,function(data,file_ref,params){
            if(data.length > 0){
                data = data+","+value;
            }else{
                data = value;
            }
            self.OS.writeFile(name,data,function(ok,file_ref,params){
                if(ok){
                    self.OS.deleteFile(filepath);
                }
                self.analyzeFile();
            });
        });
        // append file soc
        /*
        self.OS.appendFile(self.ROUTES['STAT'].path+dow+".pack",value,function(ok,file_ref,params){
            if(ok){
                self.OS.deleteFile(filepath);
            }
            self.analyzeFile();
        });
        */
    };
    this.hoursFile = [6, 12, 18, 24];
    this.hourCount = 0;
    this.sendStats = function(dow){
      self.log("# sendStats - dow : "+dow);
        if(self.dayCount < 6){
            if(self.hourCount < 4){
            	self.OS.readFile(self.ROUTES['STAT'].path+self.hoursFile[self.hourCount]+"_"+dow+".pack",function(data,file_ref,params){
                    if(data != ""){
                        var stats = {
                             id: self.core_id,
                             jsons:  "["+data+"]"
                        }
                        self.api_connector.post(self.api_url,self.api_ver,"player/stats/json",stats,function(response,status,params){
                            if(status == "success"){
                                self.log("Send stats ok for day : "+self.hoursFile[self.hourCount]+"_"+dow);
                                self.OS.deleteFile(self.ROUTES['STAT'].path+self.hoursFile[self.hourCount]+"_"+dow+".pack",function(ok,file_ref,params){
                                    if(ok){
                                        self.log("Delete stats ok for day : "+self.hoursFile[self.hourCount]+"_"+dow);
                                        self.continue2(dow);
                                    }else{
                                        self.OS.deleteFile(self.ROUTES['STAT'].path+self.hoursFile[self.hourCount]+"_"+dow+".pack",function(ok,file_ref,params){
                                            if(ok){
                                                self.log("Delete stats ok for day : "+self.hoursFile[self.hourCount]+"_"+dow);
                                            }else{
                                                self.log("Warning : duplicating stats ... for day : "+self.hoursFile[self.hourCount]+"_"+dow);
                                                self.notifyError(self.ERROR['STATISTIC_SERVICE']+3,self.name+": Function sendStats() failed : Warning : duplicating stats ... for day : "+self.hoursFile[self.hourCount]+"_"+dow);
                                            }
                                            self.continue2(dow);
                                        });
                                    }
                                });
                            }else{
                                self.log("Could not send stats for day : "+self.hoursFile[self.hourCount]+"_"+dow);
                                self.notifyError(self.ERROR['STATISTIC_SERVICE']+4,self.name+": Function sendStats() failed : Could not send stats for day : "+self.hoursFile[self.hourCount]+"_"+dow);
                                self.continue2(dow);
                            }
                        });
                    }else{
                      self.log("sending continue .... ");
                        self.continue2(dow);
                    }
                });
            }
            else{
            	self.dayCount++;
            	self.hourCount = 0;
            	self.log("sending continue .... ");
                self.continue(dow);
            }

        }else{
            self.log("sending ended .... ");
            self.stats_working = false;
            self.countWorking = 0;
        }
    };

    this.continue = function(dow){
        if(dow-1 >= 1){
            self.sendStats(dow-1);
        }else{
            self.sendStats(7);
        }
    }
    this.continue2 = function(dow){
    	self.hourCount++;
    	self.sendStats(dow);
    }
}
StatisticService.prototype = new BasicService();
